library(blockmodeling) # paketek "blockmodeling" je na voljo na spletni strani: http://www2.arnes.si/~aziber4/blockmodeling/
source("gplot.r") #malce popravljena funkcija iz paketa "sna" - datoteko "gplot.r" si skopirajte v delovni imenik

#osnovno risanje omreja "zapiski"
zapiski<-loadnetwork("zapiski.net")
plot.mat(zapiski)
plot(zapiski,mar=c(0,4.5,6,0)+0.1, main="Matrika omreja 'zapiski'",cex.val=1.5,cex.axes=1.5)
mar.def<-par("mar")
par(mar=rep(0,4))
gplot1(zapiski)

#posredni pristop - strukturna enakovrednost
par(mar=mar.def)
plot(hclust(d=sedist(zapiski),method="ward"))
plot.mat(zapiski,clu=cutree(hclust(d=sedist(zapiski),method="ward"),k=2))

#posredni pristop - regularna enakovrednost enakovrednost
plot(hclust(d=as.dist(1-REGE.ow.for(zapiski,iter=10)$E),method="ward"))
plot.mat(zapiski,clu=cutree(hclust(d=as.dist(1-REGE.ow.for(zapiski)$E),method="ward"),k=3))
zapiski.REGE.k3.par<-cutree(hclust(d=as.dist(1-REGE.ow.for(zapiski)$E),method="ward"),k=3)


#neposredni pristopi - posploeno blono modeliranje
#Homogeno blono modeliranje (vsota kvadratov) - struturna enakovrednost - optimiziranje 100 nakljunih razbiji
zapiski.ss.com.r100<-opt.random.par(zapiski,rep=100,k=3,approach="ss",blocks=c("com"))
plot(zapiski.ss.com.r100)

#Homogeno blono modeliranje (vsota kvadratov) - regularna enakovrednost - optimiziranje 2 danih razbiji
zapiski.ss.reg.2par<-opt.these.par(zapiski,par=list(zapiski.REGE.k3.par,clu(zapiski.ss.com.r100)),approach="ss",blocks=c("reg"))
plot(zapiski.ss.reg.2par)

#Homogeno blono modeliranje (vsota absolutnih odklonov) - regularna enakovrednost - optimiziranje 3 danih razbiji
zapiski.ad.reg.3par<-opt.these.par(zapiski,par=list(clu(zapiski.ss.reg.2par),zapiski.REGE.k3.par,clu(zapiski.ss.com.r100)),approach="ad",blocks=c("reg"))
plot(zapiski.ad.reg.3par)

#Intervalno (values) blono modeliranje (m = 5) - regularna enakovrednost - optimiziranje 4 danih razbiji
zapiski.val.reg.m5.4par<-opt.these.par(zapiski,par=list(clu(zapiski.ad.reg.3par),clu(zapiski.ss.reg.2par),zapiski.REGE.k3.par,clu(zapiski.ss.com.r100)),approach="val",blocks=c("null","reg"),m=5, save.checked.par =TRUE)
plot(zapiski.val.reg.m5.4par)

#Intervalno (values) blono modeliranje (m = 5) - regularna enakovrednost - optimiziranje 20 nakljunih razbiji
zapiski.val.reg.m5.r20<-opt.random.par(zapiski,seed=3010,rep=20,k=3,approach="val",blocks=c("null","reg"),m=5,skip.par=zapiski.val.reg.m5.4par$checked.par)
err(zapiski.val.reg.m5.4par)
plot(zapiski.val.reg.m5.r20)

#Intervalno (values) blono modeliranje (m = 5) - regularna enakovrednost - optimiziranje dodatnih 20 nakljunih razbiji
zapiski.val.reg.m5.r20.v2<-opt.random.par(zapiski,seed=3010, genPajekPar = FALSE,rep=20,k=3,approach="val",blocks=c("null","reg"),m=5,skip.par=zapiski.val.reg.m5.r20$checked.par)
plot(zapiski.val.reg.m5.r20.v2)
plot(zapiski.val.reg.m5.r20.v2,which=2)


#Risanje skrenega grafa (1.)
par(mar=rep(0,4))
zapiski.val.reg.m5.r20.v2.im01<-(IM(zapiski.val.reg.m5.r20.v2)!="null")+0
gplot1(zapiski.val.reg.m5.r20.v2.im01)

#Risanje skrenega grafa (2.)
zapiski.val.reg.m5.r20.v2.imVal<-find.m(M=zapiski,clu=clu(zapiski.val.reg.m5.r20.v2))
gplot1(zapiski.val.reg.m5.r20.v2.imVal)


#Risanje skrenega grafa (3.)
mean.row.col.max<-function(x,na.rm){mean(mean(apply(x,1,max)),mean(apply(x,2,max)))}
zapiski.val.reg.m5.r20.v2.imHom<-fun.by.blocks(M=zapiski,clu=clu(zapiski.val.reg.m5.r20.v2),FUN = "mean.row.col.max")
gplot1(zapiski.val.reg.m5.r20.v2.imHom)


#Risanje skrenega grafa (4.)
zapiski.val.reg.m5.r20.v2.imMean<-fun.by.blocks(M=zapiski,clu=clu(zapiski.val.reg.m5.r20.v2),FUN = "mean")
gplot1(zapiski.val.reg.m5.r20.v2.imMean)
par(mar=mar.def)

#Risanje skrenega grafa (5.)
par(mar=rep(0,4))
plot(zapiski.ad.reg.3par)
median.row.col.max<-function(x,na.rm){mean(median(apply(x,1,max)),median(apply(x,2,max)))}
zapiski.ad.reg.3par.imHom<-fun.by.blocks(M=zapiski,clu=clu(zapiski.ad.reg.3par),FUN = "median.row.col.max")
gplot1(zapiski.ad.reg.3par.imHom)
par(mar=mar.def)


#### StMarks Foodweb
#Nalaganje in risanje omreja
foodweb<-loadnetwork("SM51.net")
gplot1(foodweb)
gplot1(foodweb>0)
plot.mat(foodweb)
plot.mat.nm(foodweb)

#Posredni pristop - regularna enakovrednost - raunanje na normaliziranih matrikah
#Raunanje matrike podobnosti
foodweb.REGE.ownm.i30<-REGE.ownm.for(foodweb,iter=30)$E

#Hierarhino razvranje
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="ward"))

par(mfrow=c(1,5))
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="single"))
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="average"))
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="complete"))
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="ward"))
plot(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"))
par(mfrow=c(1,1))

#Urejene in razdeljene matrike
plot.mat.nm(M=foodweb,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="complete"),k=4),cex.axes=0.6)
plot.mat.nm(M=foodweb,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30),method="ward"),k=5),cex.axes=0.6)
plot.mat.nm(M=foodweb,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"),k=4),cex.axes=0.6)

#Risanje skrenega grafa (1.)
foodweb.row<-foodweb/matrix(rep(apply(foodweb,1,sum),times=51),byrow=FALSE,ncol=51)
foodweb.col<-foodweb/matrix(rep(apply(foodweb,2,sum),times=51),byrow=TRUE,ncol=51)
mean.row<-function(x,na.rm){mean(apply(x,1,max))}
foodweb.REGE.imRow<-fun.by.blocks(foodweb.row,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"),k=4),FUN=function(x,na.rm){mean(apply(x,1,max))})
foodweb.REGE.imRow[is.nan(foodweb.REGE.imRow)]<-0
foodweb.REGE.imCol<-fun.by.blocks(foodweb.col,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"),k=4),FUN=function(x,na.rm){mean(apply(x,2,max))})
foodweb.REGE.imCol[is.nan(foodweb.REGE.imCol)]<-0
foodweb.REGE.im<-(foodweb.REGE.imRow+foodweb.REGE.imCol)/2
foodweb.REGE.im
gplot1(foodweb.REGE.im,edge.lwd=30)

par(mar=rep(0,4))
gplot1(foodweb.REGE.im,edge.lwd=50,label=c("Rastline\nmikro","Rastlinojedi\nSediment POC","Manji/vodni\nmeosjedi/vsejedi","Ropaske\nptice"),pad=0.6)
 
#Risanje skrenega grafa (2.)
foodweb.REGE.sum.imRow<-fun.by.blocks(foodweb.row,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"),k=4),FUN=function(x,na.rm){mean(apply(x,1,sum))})
foodweb.REGE.sum.imRow[is.nan(foodweb.REGE.sum.imRow)]<-0
foodweb.REGE.sum.imCol<-fun.by.blocks(foodweb.col,clu=cutree(hclust(as.dist(1-foodweb.REGE.ownm.i30)^2,method="ward"),k=4),FUN=function(x,na.rm){mean(apply(x,2,sum))})
foodweb.REGE.sum.imCol[is.nan(foodweb.REGE.sum.imCol)]<-0
foodweb.REGE.sum.im<-(foodweb.REGE.sum.imRow+foodweb.REGE.sum.imCol)/2
foodweb.REGE.sum.im

gplot1(foodweb.REGE.sum.im)
gplot1(foodweb.REGE.im,edge.lwd=50,label=c("Rastline\nmikro","Rastlinojedi\nSediment POC","Manji/vodni\nmeosjedi/vsejedi","Ropaske\nptice"),pad=0.6)
par(mar=mar.def)
